﻿using System.Windows;
using System.Windows.Controls;
using System.Media;

using System.Drawing;

using System.ComponentModel.Composition;
using Caliburn.Micro;
using VisualComponents.Create3D;
using VisualComponents.UX.Shared;

using System.IO;
using System.Windows.Markup;
using System.Xml;
using System.Windows.Media.Imaging;
using System.Windows.Media;
//using System.Threading.Tasks;
//using System.Threading;
using System.Diagnostics;
using System;
using System.Timers;

//I do it this way: 1) create "WPF Application" 2) remove App.xaml 3) change Project properties -> Application Output type: to Class Library (originally there is Windows Application)
//http://stackoverflow.com/questions/3573339/no-creation-of-a-wpf-window-in-a-dll-project

namespace WpfApplication3
{
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();

            //****************** Test Image *****************/
            // http://www.nerdparadise.com/tech/csharp/wpfimageediting/

            /*int width = 1280;
            int height = 720;

            // Create a writeable bitmap (which is a valid WPF Image Source
            WriteableBitmap bitmap = new WriteableBitmap(width, height, 96, 96, PixelFormats.Bgra32, null);

            // Create an array of pixels to contain pixel color values
            uint[] pixels = new uint[width * height];

            int red;
            int green;
            int blue;
            int alpha;

            for (int x = 0; x < width; ++x)
            {
                for (int y = 0; y < height; ++y)
                {
                    int i = width * y + x;

                    red = 0;
                    green = 255 * y / height;
                    blue = 255 * (width - x) / width;
                    alpha = 255;

                    pixels[i] = (uint)((blue << 24) + (green << 16) + (red << 8) + alpha);
                }
            }

            // apply pixels to bitmap
            bitmap.WritePixels(new Int32Rect(0, 0, width, height), pixels, width * 4, 0);

            // set image source to the new bitmap
            this.MainImage.Source = bitmap;
            */

            //_wb = new WriteableBitmap(1280, 720, 96, 96, PixelFormats.Bgr32, null);
            //this.MainImage.Source = _wb;
        }
    }

    //****************** Conversion ********************************************
    //https://social.msdn.microsoft.com/Forums/sqlserver/en-US/a9365644-bde1-4995-8b35-bcb31a866096/uwp-writeablebitmap-to-byte-array-then-byte-array-to-writeablebitmap?forum=wpdevelop
    // nur UWP Apps ab Windows 10 !! shit!!!!!
    /*public async Task PixelBufferToWriteableBitmap(WriteableBitmap wb, byte[] bgra)
    {
        using (Stream stream = wb.PixelBuffer.AsStream())
        {
            await stream.WriteAsync(bgra, 0, bgra.Length);
        }
    }

    public async Task<WriteableBitmap> PixelBufferToWriteableBitmap(byte[] bgra, int width, int height)
    {
        var wb = new WriteableBitmap(width, height);
        await PixelBufferToWriteableBitmap(wb, bgra);
        return wb;
    }
    */


    [Export(typeof(IPlugin))]
    public class MyPlugin : IPlugin
    {
        private IApplication _app = null;
        private MainWindow _win = null;
        static IMessageService ms = IoC.Get<IMessageService>();
        private IWindow3D _win3D = null;
        private IViewport _viewport = null;
        //private NeverEndingTaskNew _task = null;
        private Timer t1 = null;
        private WriteableBitmap _wb = null;
        private Stopwatch stopWatch = new Stopwatch();

        [ImportingConstructor]
        public MyPlugin([Import(typeof(IApplication))] IApplication app)
        {
            _app = app;
            _win = new MainWindow();
            _win3D = _app.Create3DWindow("test");
            //_viewport = new IViewport(); //IViewport lässt eine Instanzierung nicht zu
            _viewport = IoC.Get<IViewport>();
            //ms.AppendMessage("1", MessageLevel.Warning);
            //ms.AppendMessage("2", MessageLevel.Warning);
        }

        void IPlugin.Exit()
        {
            t1.Enabled = false;
            //ms.AppendMessage("4", MessageLevel.Warning);
        }

        void IPlugin.Initialize()
        {
            //ms.AppendMessage("3", MessageLevel.Warning);
            
            /************ Show Window ***********************/
            //_win.Activate();
            //_win.Name = "blabla";
            //_win.Content = (Viewport3D) IoC.Get<IViewport>().RootElement; //das funktioniert nicht weil UI nicht gelöst werden kann
            _win.Show();

            /***********Modify Window3D ********************/
            //_viewport.SetWindow(_win3D);
            //_app.ActiveWindow = _win3D; //nur das hat einluss auf ActiveWindow nicht setwindow
            //ms.AppendMessage("Active Window: " + _app.ActiveWindow.Name, MessageLevel.Warning);

            /*Bitmap*/
            //http://stackoverflow.com/questions/21555394/how-to-create-bitmap-from-byte-array
            // or try http://www.saramgsilva.com/index.php/2013/c-how-to-convert-byte-to-bitmap/
            //Bitmap bmp;
            //using (var ms = new MemoryStream(imageData))
            //{
            //    bmp = new Bitmap(ms);
            //}
            //Canvas canva = new Canvas();
            //canva.

            //http://charlespetzold.com/blog/2011/10/SpinPaint-for-Windows-8.html
            //WriteableBitmap test;
     

            //*******************************************************************
            //***** Einmal darstellen SurfaceToContinuesBuffer -> besser ********
            //*******************************************************************
            //WriteableBitmap wb = new WriteableBitmap(1280, 720, 96, 96, PixelFormats.Bgr32, null); //pbgra32 funktioniert nicht ... alpha channel???
            //_win.MainImage.Source = wb;
            //_app.SetRecordingMode(_app.ActiveWindow, true, 1280, 720);
            //byte[] test = _app.SurfaceToContinuousBuffer(1280, 720);
            //ms.AppendMessage("Length:" + test.Length, MessageLevel.Warning);
            //wb.WritePixels(new Int32Rect(0, 0, 1280, 720), test, 1280 * 4, 0);

            //*******************************************************************
            //*****Einmal darstellen SurfaceToBuffer -> schlechter ********
            //*******************************************************************
            //_wb = new WriteableBitmap(1280, 720, 96, 96, PixelFormats.Bgr32, null);
            //_win.MainImage.Source = _wb;
            //_app.SurfacePrepareRender(_app.ActiveWindow);
            //_app.SurfaceStartRender(_app.ActiveWindow);
            //_app.SurfaceWaitRender(_app.ActiveWindow);

            //byte[] test = _app.SurfaceToBuffer(ImageFormat.DDS, 1280, 720);
            ////ms.AppendMessage("Length:" + test.Length, MessageLevel.Warning);
            ////dump DDS Header Offset = 128 !!!
            //byte[] test2 = new byte[1280 * 720 * 4];
            //Array.Copy(test, 128, test2, 0, 1280 * 720 * 4); //don't use resize -> performance issues
            //_wb.WritePixels(new Int32Rect(0, 0, 1280, 720), test2, 1280 * 4, 0);

            //***********************************************
            //*****endlos darstellen SurfaceToBuffer ********
            //***********************************************
            //_wb = new WriteableBitmap(1280, 720, 96, 96, PixelFormats.Bgr32, null);
            //_win.MainImage.Source = _wb;
            ////_app.SurfacePrepareRender(_app.ActiveWindow);
            ////_app.SurfaceStartRender(_app.ActiveWindow);
            ////_app.SurfaceWaitRender(_app.ActiveWindow);

            //t1 = new Timer(10000);
            //t1.Elapsed += updateImage;
            //t1.Interval = 2000;
            //t1.Enabled = true;


            //******************************************************************
            //**** Endlos darstellen SurfaceToContinuesBuffer -> besser*********
            //******************************************************************
            _wb = new WriteableBitmap(1280, 720, 96, 96, PixelFormats.Bgr32, null);
            _win.MainImage.Source = _wb;
            _app.SetRecordingMode(_app.ActiveWindow, true, 1280, 720);

            t1 = new Timer(10000);
            t1.Elapsed += updateImage;
            t1.Interval = 33;
            t1.Enabled = true;
        }

        private void updateImage(object sender, ElapsedEventArgs e)
        {
            //http://physudo.blogspot.de/2013/09/c-wpf-invoken.html
            Application.Current.Dispatcher.BeginInvoke(new System.Action(() =>
            {
                //stopWatch.Reset();
                //stopWatch.Start();
                _wb.WritePixels(new Int32Rect(0, 0, 1280, 720), _app.SurfaceToContinuousBuffer(1280, 720), 1280 * 4, 0);

                //byte[] test = _app.SurfaceToBuffer(ImageFormat.DDS, 1280, 720);
                //byte[] test2 = new byte[1280 * 720 * 4];
                //Array.Copy(test, 128, test2, 0, 1280 * 720 * 4); 
                //_wb.WritePixels(new Int32Rect(0, 0, 1280, 720), test2, 1280 * 4, 0);

                //stopWatch.Stop();
                //ms.AppendMessage("Time: " + stopWatch.Elapsed.TotalMilliseconds, MessageLevel.Warning);
            }));
        }
        // Time Measurement Results SurfaceToContinuousBuffer:
        // Laptop: FX 1800M
        // Layout: Rotation Index Table
        // Method: _wb.WritePixels(new Int32Rect(0, 0, 1280, 720), _app.SurfaceToContinuousBuffer(1280, 720), 1280 * 4, 0);
        // Mittelwert <10ms
        // Peaks unter Last 25ms
        //--> max 30Hz sinnvoll

        // Time Measurement Results SurfaceToBuffer:
        // Laptop: FX 1800M
        // Layout: leer
        // Mittelwert 950ms
        // -->schrott


        //http://stackoverflow.com/questions/13695499/proper-way-to-implement-a-never-ending-task-timers-vs-task
        /*public abstract class NeverEndingTask
        {
            // Using a CTS allows NeverEndingTask to "cancel itself"
            private readonly CancellationTokenSource _cts = new CancellationTokenSource();

            protected NeverEndingTask()
            {
                TheNeverEndingTask = new Task(
                   () =>
                   {
                // Wait to see if we get cancelled...
                while (!_cts.Token.WaitHandle.WaitOne(ExecutionLoopDelayMs))
                       {
                    // Otherwise execute our code...
                    ExecutionCore(_cts.Token);
                       }
                // If we were cancelled, use the idiomatic way to terminate task
                _cts.Token.ThrowIfCancellationRequested();
                   },
                   _cts.Token,
                   TaskCreationOptions.DenyChildAttach | TaskCreationOptions.LongRunning);

                // Do not forget to observe faulted tasks - for NeverEndingTask faults are probably never desirable
                TheNeverEndingTask.ContinueWith(x =>
                {
                    Trace.TraceError(x.Exception.InnerException.Message);
                    // Log/Fire Events etc.
                }, TaskContinuationOptions.OnlyOnFaulted);

            }

            protected readonly int ExecutionLoopDelayMs = 0;
            protected Task TheNeverEndingTask;

            public void Start()
            {
                // Should throw if you try to start twice...
                TheNeverEndingTask.Start();
            }

            protected abstract void ExecutionCore(CancellationToken cancellationToken);

            public void Stop()
            {
                // This code should be reentrant...
                _cts.Cancel();
                TheNeverEndingTask.Wait();
            }
        }
        */

    }
}
